#include "IRLibAll.h"

//Motoren
const int ENABLE = 4;
const int IN1 = 9;
const int IN2 = 10;
const int IN3 = 5;
const int IN4 = 6;

// Ultraschall
int trigger = 11;
int echo = 12;
long dauer = 0;
long entfernung = 0;

// Infrarot
IRrecvPCI myReceiver(3);
IRdecode myDecoder;

void setup() {

  Serial.begin(9600);

  // Motoren
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(IN3, OUTPUT);
  pinMode(IN4, OUTPUT);
  //pinMode(ENABLE, OUTPUT);

  //Ultraschall
  pinMode(trigger, OUTPUT);
  pinMode(echo, INPUT);

  // Infrarot
  delay(2000); while (!Serial);
  myReceiver.enableIRIn();
  pinMode(3, OUTPUT);
}


void loop() {

  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);
  analogWrite(IN2, 50);
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4, LOW);
  analogWrite(IN4, 50);

  //Ultraschall
  digitalWrite(trigger, LOW);
  delay(5);
  digitalWrite(trigger, HIGH);
  delay(10);
  digitalWrite(trigger, LOW);
  dauer = pulseIn(echo, HIGH);
  entfernung = (dauer / 2) * 0.03432;
 /* if (entfernung >= 500 || entfernung <= 0)
  {
    Serial.println("Kein Messwert");
  }
  else
  {
    Serial.print(entfernung);
    Serial.println(" cm");
  }
  delay(500);*/

if (entfernung <= 60)

  {
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);
  analogWrite(IN2, 0);
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4, LOW);
  analogWrite(IN4, 0);

  }

  //Infrarot
  if (myReceiver.getResults()) {
    myDecoder.decode();
    myDecoder.dumpResults(true);
    myReceiver.enableIRIn();
    Serial.println("detected");
  }
}

// Motorbewegungen
void stopmove(int pwm) {
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);
  analogWrite(IN2, pwm);
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4, LOW);
  analogWrite(IN4, pwm);
}

void moveforward(int pwm) {
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);
  analogWrite(IN2, pwm);
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4, LOW);
  analogWrite(IN4, pwm);
}

void moveforwardright(int pwm) {
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);
  analogWrite(IN2, 0);
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4, LOW);
  analogWrite(IN4, pwm);
}

void moveforwardleft(int pwm) {
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);
  analogWrite(IN2, pwm);
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4, LOW);
  analogWrite(IN4, 0);
}


void movebackward(int pwm) {
  digitalWrite(IN1, LOW);
  digitalWrite(IN2, HIGH);
  analogWrite(IN2, pwm);
  digitalWrite(IN3, LOW);
  digitalWrite(IN4, HIGH);
  analogWrite(IN4, pwm);
}


